from collections import OrderedDict
import torch.nn as nn

# https://machinelearningmastery.com/building-multilayer-perceptron-models-in-pytorch/
mlp_model = nn.Sequential(OrderedDict([
    ('dense1', nn.Linear(1, 128)),
    ('act1', nn.ReLU()),
    ('dense2', nn.Linear(128, 128)),
    ('act2', nn.ReLU()),
    ('output', nn.Linear(128, 128)),
    ('outact', nn.Sigmoid()),
]))